#include "huhfa.h"

void huhfa::output(string result, bool rep){
    if(!input_fail){
        result.append(".huhfa");
        fstream fileout(result.c_str() , ios::out);

        int h=1;

        //For every number of vertices a facet can has
        for(map<int ,map<int, vector<int> > >::iterator jt=classes.begin(); jt!=classes.end(); jt++){
            fileout<<"Classes of facets including "<<(*jt).first<<" vertices:"<<endl;
            fileout<<endl;
            //Go through all classes
            for(map<int, vector<int> >::iterator it=(*jt).second.begin(); it!=(*jt).second.end(); it++){
                    fileout<<"Class "<<h++<<"\t("<< (*it).second.size() <<" members)"<< endl;
                    fileout<<endl;
                    //Store the inequalities
                    for(int j=0; j<(*it).second.size(); j++){
                        //fileout<<"("<<(*it).second[j]+1<<")\t";
                        for(int k=0; k<n; k++){
                            if( inequalities[(*it).second[j]][k]!=0 ){
                                if( inequalities[(*it).second[j]][k]>0 ){
                                    fileout<<"+";
                                }
                                if(inequalities[(*it).second[j]][k]==-1){
                                    fileout<<"- ";
                                }
                                else if(inequalities[(*it).second[j]][k]!=1){
                                    fileout<<inequalities[(*it).second[j]][k];
                                }
                                else{
                                    fileout<<" ";
                                }
                                fileout<<" "<<variables[k]<<" ";
                            }
                        }
                        fileout<<"<= "<<inequalities[(*it).second[j]][n]<<endl;
                        if(rep){
                            break;
                        }
                    }
                    fileout<<endl;
                }
                fileout<<endl;
                fileout<<endl;
            }
        cout<<"The results have been stored in '"<<result<<"'"<<endl;
    }
}

